VERSION 5.00
Begin VB.Form frmCodeBreak 
   Caption         =   "Break Example"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4665
   ForeColor       =   &H00FFFFFF&
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4665
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pBreak 
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3105
      Left            =   30
      ScaleHeight     =   207
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   29
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   60
      Width           =   435
   End
   Begin VB.TextBox txtBox 
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3105
      HideSelection   =   0   'False
      Left            =   510
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   60
      Width           =   4125
   End
End
Attribute VB_Name = "frmCodeBreak"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'//Notice:  m_ is used in this form's code because of the
'//Following...
'//A) Forms are Private modules with a GUI counterpart.
'//B) In a sense, m_ means module level.... Since it is
'//   in essence, a private module, m_ seems appropriate
'//   But again, as Rod says, it is just a matter of preference.
Option Explicit
    '//Strict command, to force declaration of variables
    '//Its my coding style...
Private Type m_tdbBreaks
    Count As Long
        '//Number of breaks
    Breaks() As Long
        '//Break numbers, representing the lines that the
        '//break exists on.
End Type
Private m_bksBreaks As m_tdbBreaks
    '//Private varialbe holding Break data
Private m_decTextContext As DeviceContext
    '//TextBox device context
Private WithEvents MyCommand As SubclassMsg
Attribute MyCommand.VB_VarHelpID = -1
    '//Why use an object for each message?
    '//Simple, it makes the code easier to follow
    '//It's easier to follow a single event, then a select
    '//case from 'hell' (so to speak)
Private WithEvents TextBoxPaint As SubclassMsg
Attribute TextBoxPaint.VB_VarHelpID = -1
Private TextBoxSubclass As Subclass
Attribute TextBoxSubclass.VB_VarHelpID = -1
Private MySubclass As Subclass
Private m_lngIncrement As Long
Private Sub Form_Load()
    Set m_decTextContext = New DeviceContext
    m_decTextContext.Handle = GetWindowDC(txtBox.hwnd)
    Set MySubclass = New Subclass
    MySubclass.Handle = hwnd
    Set TextBoxSubclass = New Subclass
    TextBoxSubclass.Handle = txtBox.hwnd
    Set MyCommand = MySubclass.Messages.Add(WM_COMMAND)
    Set TextBoxPaint = TextBoxSubclass.Messages.Add(WM_PAINT)
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    pBreak.Move 30, 30, pBreak.Width, ScaleHeight - 60
    txtBox.Move pBreak.Left + pBreak.Width, pBreak.Top, ScaleWidth - (pBreak.Width + (pBreak.Left * 2)), pBreak.Height
    Refresh
End Sub

Private Sub pBreak_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim FirstLine As Long
        '//First visible line
    Dim Line As Long
        '//Line Clicked
    Dim LoopVar As Long
        '//Loop var
    Dim Found As Boolean
        '//If its found in the break array, then it
        '//indicates that it doesn't need to be re-added
    If Button = 1 Then
        '//Make sure its not a simple mouse over, or the
        '//Context menu button
        FirstLine = SendMessage(txtBox.hwnd, EM_GETFIRSTVISIBLELINE, 0, 0)
            '//Retrieve the first line
        Line = Y \ pBreak.TextHeight("") + FirstLine
            '//Obtain the line in correspondance to the y value
        For LoopVar = 1 To m_bksBreaks.Count
            '//Loop through the breaks
            If m_bksBreaks.Breaks(LoopVar) = Line Then
                '//If the Break line is equal to that of the
                '//Line clicked, then ...
                RemoveBreak m_bksBreaks, LoopVar
                    '//Remove the break
                Found = True
                    '//Set variable so that it isn't
                    '//re-added
                Exit For
                    '//Exit loop
            End If
        Next '//[LoopVar]
        If Not Found Then
            '//If its not found, then...
            AddBreak m_bksBreaks, Line
            '//Add the break here
        End If
        txtBox.SetFocus
            '//Set focus to the textbox
    End If
    txtBox.Refresh
    RedrawBreaks
End Sub

Private Sub RedrawBreaks()
    On Error Resume Next
    Dim FirstLine As Long
        '//First visible line var
    Dim LoopVar As Long
        '//Loop var
    Dim BreakLoop As Long
        '//Break loop var
    Dim CurrentLine As String
    FirstLine = SendMessage(txtBox.hwnd, EM_GETFIRSTVISIBLELINE, 0, 0)
        '//Get first line visible
    pBreak.FillStyle = FillStyleConstants.vbFSSolid
        '//Set fillstyle
    pBreak.FillColor = RGB(128, 0, 0)
        '//Set fill color
    pBreak.Line (0, 0)-Step(pBreak.ScaleWidth, pBreak.ScaleHeight), pBreak.BackColor, BF
        '//Clear previous data (cls didn't work ... )
    For BreakLoop = 1 To m_bksBreaks.Count
        '//Loop through breaks
        For LoopVar = 0 To ((pBreak.ScaleHeight - 16) \ pBreak.TextHeight("")) - 1
            '//loop from zero to the number of lines
            '//visible in the specified height
            If FirstLine + LoopVar = m_bksBreaks.Breaks(BreakLoop) Then
                '//If the line equals that of the break's,
                '//then ...
                pBreak.Circle (pBreak.TextHeight("") \ 3 + 3, (LoopVar * (pBreak.TextHeight(""))) + pBreak.TextHeight("") / 2), pBreak.TextHeight("") \ 3
                    '//Draw it
                CurrentLine = GetEditLine(txtBox.hwnd, FirstLine + LoopVar)
                If pBreak.TextWidth(CurrentLine) > (txtBox.Width / Screen.TwipsPerPixelX) - 16 Then
                    m_decTextContext.DrawLine 0, (LoopVar * (pBreak.TextHeight(""))), txtBox.Width / Screen.TwipsPerPixelX - 16, (LoopVar * (pBreak.TextHeight(""))), PS_SOLID, 1, RGB(128, 0, 0)
                    m_decTextContext.DrawLine 0, ((LoopVar + 1) * (pBreak.TextHeight(""))) - 1, txtBox.Width / Screen.TwipsPerPixelX - 16, ((LoopVar + 1) * (pBreak.TextHeight(""))) - 1, PS_SOLID, 1, RGB(128, 0, 0)
                Else
                    m_decTextContext.DrawLine 0, (LoopVar * (pBreak.TextHeight(""))), pBreak.TextWidth(CurrentLine), (LoopVar * (pBreak.TextHeight(""))), PS_SOLID, 1, RGB(128, 0, 0)
                    m_decTextContext.DrawLine 0, ((LoopVar + 1) * (pBreak.TextHeight(""))) - 1, pBreak.TextWidth(CurrentLine), ((LoopVar + 1) * (pBreak.TextHeight(""))) - 1, PS_SOLID, 1, RGB(128, 0, 0)
                End If
            End If
        Next '//[LoopVar]
    Next '//[m_lngBreak]
    pBreak.FillColor = vbBlack
        '//Reset fill color (pointless, but 'eh..
    pBreak.Line (pBreak.ScaleWidth - 1, 0)-Step(0, pBreak.ScaleHeight), vbBlack
        '//Put the line to the right of the box,
        '//Pointless as well, but it helps
        '//the mimicing process
    pBreak.FillStyle = FillStyleConstants.vbFSTransparent
        '//Set fillstyle to transparent again
End Sub

Private Sub AddBreak(Breaks As m_tdbBreaks, Line As Long)
    With Breaks
        '//Select the breaks
        If .Count = 0 Then
            '//If there aren't any, preserve errors
            ReDim .Breaks(1 To 1)
                '//Redimention the array
        Else
            ReDim Preserve .Breaks(1 To .Count + 1)
                '//Redimention and preserve data
        End If
        .Count = .Count + 1
            '//Increment count
        .Breaks(.Count) = Line
            '//Set value
    End With '//[Breaks]
End Sub

Private Sub Shift(Breaks As m_tdbBreaks, Optional Start As Long = 1, Optional LineCount As Long = 1)
    Dim m_lngLoop As Long
        '//Loop var
    With Breaks
        '//Select the breaks
        For m_lngLoop = Start To .Count
            '//Loop through breaks
            .Breaks(m_lngLoop) = .Breaks(m_lngLoop) + LineCount
                '//Shift the values corresponding
                '//with the argumental data
        Next '//[m_lngLoop]
    End With '//[Breaks]
End Sub

Private Sub RemoveBreak(Breaks As m_tdbBreaks, Index As Long)
    Dim LoopVar As Long
    '//Loop var
    With Breaks
        '//Select the breaks
        .Count = .Count - 1
            '//Decrement count
        For LoopVar = Index To .Count
            '//Loop to the number of items
            .Breaks(LoopVar) = .Breaks(LoopVar + 1)
                '//Squeeze out old data...
        Next '//[LoopVar]
        If .Count > 0 Then
            '//If the count is still greater then zero, then...
            ReDim Preserve .Breaks(1 To .Count)
                '//Preserve existing data.
        End If
    End With '//[Breaks]
End Sub

Private Sub MyCommand_Invoke(wParam As Long, lParam As Long, Result As Long)
    If lParam = txtBox.hwnd Then
        Select Case HIWORD(wParam)
            Case EN_CHANGE
                Refresh
                RedrawBreaks
        End Select
    End If
End Sub

Private Sub pBreak_Paint()
    Refresh
    RedrawBreaks
End Sub

Private Sub TextBoxPaint_Invoke(wParam As Long, lParam As Long, Result As Long)
    Call RedrawBreaks
        '//Calling the refresh here is a BIG mistake..
        '//It forces a LOT of redraws
End Sub

Private Sub txtBox_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        '//ToDo: Not yet implemented!
        '//Hint: Shift Command (might involve API for
                             '//More accurate results,
                             '//in case something was
                             '//selected.)
    End If
End Sub
