VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PointerObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'//|--------------------------------------------------------------------|
'//| Name  :  PointerObject                                             |
'//| Author:  Linguar (Linguar@rpgmaker.net)                            |
'//|--------------------------------------------------------------------|
'//|Description:                                                        |
'//|This class is to allow for the nodes in a tree view to be           |
'//|Directly fixated to the object for which it represents.  It         |
'//|Cuts down on code and complexity.  It also makes the most sense.    |
'//|Notice:                                                             |
'//|This class is also excellent for CallBacks and class                |
'//|Association.                                                        |
'//|--------------------------------------------------------------------|
Option Explicit
Private r_lngPointer As Long
Private r_objObject As Object
Public Property Get Pointer() As Long
    Pointer = r_lngPointer
End Property

Public Property Let Pointer(ByRef v_lngPointer As Long)
    Dim m_objTemp As Object
    CopyMemory m_objTemp, v_lngPointer, 4
        '//Copy Object to a temporary (unstable) object
    Set r_objObject = m_objTemp
        'Safely 'copy' the object to the reference
    CopyMemory m_objTemp, Nothing, 4
        'Remove old unstable reference so the project doesn't crash
        'when it is released.
    r_lngPointer = v_lngPointer
        'Set the pointer
End Property

Public Property Get Object() As Object
    Set Object = r_objObject
        'Return object
End Property

Public Property Set Object(ByVal v_objObject As Object)
    Set r_objObject = v_objObject
    r_lngPointer = ObjPtr(v_objObject)
        'Update Pointer
End Property

Public Property Let Object(ByVal v_objObject As Object)
    Set r_objObject = v_objObject
    r_lngPointer = ObjPtr(v_objObject)
        'Update Pointer
End Property
