Attribute VB_Name = "modCallBack"
Option Explicit
'//One note about subclasses... This is complex for such
'//a small example, for one reason:  I hate doing things twice.

Public Function WindowsProc(ByVal Handle As Long, ByVal Message As WindowsMessages, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim MessagePointer As PointerObject
    Dim OldProcedure As Long
    Dim Subclass_Count As Long
    Dim Subclass_Loop As Long
    Dim Subclass_Pointer As Long
    Dim Subclass_Current As Subclass
    Dim MessageResult As Long
    Subclass_Count = GetProp(Handle, "Subclasses.Count")
        '//Return the number of subclasses
    For Subclass_Loop = 1 To Subclass_Count
        '//Loop through subclasses
        Subclass_Pointer = GetProp(Handle, "Subclasses(" & Subclass_Loop & ").Pointer")
            '//Retrieve the pointer
        If Subclass_Pointer > 0 Then
            '//Just in case the pointer happens to be invalid
            Set MessagePointer = New PointerObject
                '//Set the message pointer to a new instance
            MessagePointer.Pointer = Subclass_Pointer
                '//Set the pointer of the pointer object
            Set Subclass_Current = MessagePointer.Object
                '//Retrieve the object
            MessageResult = DispatchMessage(Message, Subclass_Current, wParam, lParam)
                '//Dispatch the messages and get the result
                '//Of the dispatch
            Set MessagePointer = Nothing
                '//Destroy pointer object
        End If
    Next '//[Subclass_Loop]
    OldProcedure = GetProp(Handle, "OldProcedure")
        '//Get the old proc.
    If MessageResult <> 0 Then
        '//If the message result has changed.
        WindowsProc = MessageResult
            '//Return the value
    Else
        WindowsProc = CallWindowProc(OldProcedure, Handle, Message, wParam, lParam)
            '//Call the old window procedure.
    End If
End Function

Public Function AttachSubclass(Subclass As Subclass)
    Dim Handle As Long
    Dim Subclass_Count As Long
    Dim Messages_Count As Long
    Dim OldProcedure As Long
    Handle = Subclass.Handle
        '//Let the handle value
    Subclass_Count = GetProp(Handle, "Subclasses.Count")
        '//Get the number of subclasses
    Subclass_Count = Subclass_Count + 1
        '//Increment it
    SetProp Handle, "Subclasses.Count", Subclass_Count
        '//Update the subclass count property
    SetProp Handle, "Subclasses(" & Subclass_Count & ").Pointer", ObjPtr(Subclass)
        '//Set the pointer property
    If Subclass_Count = 1 Then
        '//If the count is one, then...
        OldProcedure = GetWindowLong(Handle, GWL_WNDPROC)
            '//Get the old proc
        SetProp Handle, "OldProcedure", OldProcedure
            '//Set the old proc prop
        SetWindowLong Handle, GWL_WNDPROC, AddressOf WindowsProc
            '//Set the new proc value
    End If
End Function

Public Sub DetachSubclass(Subclass As Subclass)
    Dim Handle As Long
    Dim Subclass_Count As Long
    Dim Subclass_Loop As Long
    Dim Subclass_Index As Long
    Dim Subclass_Pointer As Long
    Dim OldProcedure As Long
    Handle = Subclass.Handle
        '//let the handle value
    Subclass_Count = GetProp(Handle, "Subclasses.Count")
        '//Get the subclass count
    Subclass_Index = GetSubclassIndex(Handle, Subclass)
        '//Get the index
    For Subclass_Loop = Subclass_Index To Subclass_Count - 1
        '//Loop through the subclasses
        Subclass_Pointer = GetProp(Handle, "Subclasses(" & Subclass_Loop + 1 & ").Pointer")
            '//Get the pointer of the next item
        SetProp Handle, "Subclasses(" & Subclass_Loop & ").Pointer", Subclass_Pointer
            '//Set the pointer of the current item to that
            '//of the next item, this will eventually squeeze
            '//out the pointer of the current item
    Next
    RemoveProp Handle, "Subclasses(" & Subclass_Count & ").Pointer"
        '//Delete the pointer reference to the last item.
    Subclass_Count = Subclass_Count - 1
        '//Decrement the subclass count
    SetProp Handle, "Subclasses.Count", Subclass_Count
        '//Set the new value
    If Subclass_Count = 0 Then
        '//If there are none left...
        OldProcedure = GetProp(Handle, "OldProcedure")
            '//Restore the old window proc
        SetWindowLong Handle, GWL_WNDPROC, OldProcedure
            '//Set the window proc
        RemoveProp Handle, "Subclasses.Count"
            '//Remove the count handle
        RemoveProp Handle, "OldProcedure"
            '//Remove the old window proc prop
    End If
    Subclass.Attached = False
        '//It is no longer attached
End Sub

Public Function DispatchMessage(Message As WindowsMessages, Subclass As Subclass, wParam As Long, lParam As Long) As Long
    Dim Result As Long
    Dim EnumMessage As SubclassMsg
    Dim Stored As Long
    Result = Subclass.Invoke(Message, wParam, lParam)
        '//Check to see
    If Result <> 0 Then
        Stored = Result
    End If
    For Each EnumMessage In Subclass.Messages
        If EnumMessage.Message = Message Then
            Result = EnumMessage.Invoke(wParam, lParam)
            If Result <> 0 And Stored = 0 Then
                Stored = Result
            End If
        End If
    Next
    DispatchMessage = Result
End Function

Public Function GetSubclassIndex(Handle As Long, Subclass As Subclass) As Long
    Dim Subclass_Count As Long
    Dim Subclass_Loop As Long
    Dim Subclass_Pointer As Long
    Subclass_Count = GetProp(Handle, "Subclasses.Count")
        '//Get the subclass count
    For Subclass_Loop = 1 To Subclass_Count
        '//Loop through the subclasses
        Subclass_Pointer = GetProp(Handle, "Subclasses(" & Subclass_Loop & ").Pointer")
            '//Get the pointer of the current item.
        If Subclass_Pointer = ObjPtr(Subclass) Then
            '//If it matches that of the subclass, then...
            GetSubclassIndex = Subclass_Loop
                '//Return the value
            Exit For
                '//Exit the loop
        End If
    Next '//[Subclass_Loop]
End Function
