Attribute VB_Name = "modMain"
Option Explicit
'//---API Declares---//
'//---Kernel32.dll---//
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
    '//Copies memory from the source to the destination in the
    '//size specified
'//!--Kernel32.dll---//
'//---GDI32.dll---//
Public Declare Function GetDCPenColor Lib "gdi32" (ByVal hDC As Long) As Long
    '//Returns the Device Context's Pen color.
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
    '//Selects a new, given, object to the device context.
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
    '//Deletes a GDI object and frees the associated memory
Public Declare Function CreatePen Lib "gdi32" (ByVal PenStyle As PenStyle, ByVal Width As Long, ByVal Color As Long) As Long
    '//With the Penstyle, Width, and color provided,
    '//it gives a resulted pen, if the information is to
    '//the given specifications (correct).
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
    '//Makes a line from the Current X/Y of the Device
    '//Context to the Given X/Y values.
Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
    '//Moves the current X/Y values to the specified
    '//locations on the Device Context Given.
'//!--GDI32.dll---//
'//---User32.dll---//
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    '//Calls the given window's window procedure, thereby
    '//allowing the associated windows procedure to take care
    '//of anything you didn't.
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal Index As GetWindowLongFlags, ByVal dwNewLong As Long) As Long
    '//Sets the given window property to the given value
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal Index As GetWindowLongFlags) As Long
    '//Returns the given widnow property
Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
    '//Gets a windows property
Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
    '//Sets a windows property
Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
    '//Removes a windows property
Public Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
    '//Gets a windows device context.
Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal Msg As Long, wParam As Any, lParam As Any) As Long
    '//Send message api, sends a Windows Message to query
    '//or give a command to a specific window.
'//!--User32.dll---//
'//!--API Declares---//
'//---Edit messages---//
Public Enum EditMessages
    EM_GETFIRSTVISIBLELINE = &HCE
        '//Get first visible line Edit Message
    EM_CANUNDO = &HC6
    EM_EMPTYUNDOBUFFER = &HCD
    EM_FMTLINES = &HC8
    EM_GETHANDLE = &HBD
    EM_GETLINE = &HC4
    EM_GETLINECOUNT = &HBA
    EM_GETMODIFY = &HB8
    EM_GETPASSWORDCHAR = &HD2
    EM_GETRECT = &HB2
    EM_GETSEL = &HB0
    EM_GETTHUMB = &HBE
    EM_GETWORDBREAKPROC = &HD1
    EM_LIMITTEXT = &HC5
    EM_LINEFROMCHAR = &HC9
    EM_LINEINDEX = &HBB
    EM_LINELENGTH = &HC1
    EM_LINESCROLL = &HB6
    EM_REPLACESEL = &HC2
    EM_SCROLL = &HB5
    EM_SCROLLCARET = &HB7
    EM_SETHANDLE = &HBC
    EM_SETMODIFY = &HB9
    EM_SETPASSWORDCHAR = &HCC
    EM_SETREADONLY = &HCF
    EM_SETRECT = &HB3
    EM_SETRECTNP = &HB4
    EM_SETSEL = &HB1
    EM_SETTABSTOPS = &HCB
    EM_SETWORDBREAKPROC = &HD0
    EM_UNDO = &HC7
End Enum
'//!--Edit messages---//
'//---Edit Notifications---//
'//Edit notifications are sent through the window's
'//wParam argument in its windows procedure.
Public Const EN_CHANGE = &H300
Public Const EN_VSCROLL = &H602
    '//When the vertical scroll bar changes...
Public Const EN_HSCROLL = &H601
    '//When the horazontal Scroll bar changes...
'//!--Edit Notifications---//
Public Enum PenStyle
    PS_SOLID = &H0&
        '//Solid Brush
    PS_DASH = &H1&
        '//Dashed Brush "----"
    PS_DOT = &H2&
        '//Dot Brush "...."
    PS_DASHDOT = &H3&
        '//Dash, dot, brush "-.-."
    PS_DASHDOTDOT = &H4&
        '//Dash, Dot, dot, brush "-..-"
    PS_NULL = &H5&
        '//Null Brush "???"
    PS_INSIDEFRAME = &H6&
        '//Inside frame brush, kinda like "B" flag with the
        '//standard Line Method.
End Enum
Public Type POINTAPI
    '//Point API structure...
    X As Long
        '//X-Position
    Y As Long
        '//Y-Position
End Type
Public Enum GetWindowLongFlags
    GWL_WNDPROC = (-4&)
    GWL_USERDATA = (-21&)
    GWL_STYLE = (-16&)
    GWL_ID = (-12&)
    GWL_HWNDPARENT = (-8&)
    GWL_HINSTANCE = (-6&)
    GWL_EXSTYLE = (-20&)
End Enum
Public Enum WindowsMessages
    WM_USER = &H400&
    WM_ACTIVATE = &H6&
    WM_ACTIVATEAPP = &H1C&
    WM_ASKCBFORMATNAME = &H30C&
    WM_CANCELJOURNAL = &H4B&
    WM_CANCELMODE = &H1F&
    WM_CHANGECBCHAIN = &H30D&
    WM_CHAR = &H102&
    WM_CHARTOITEM = &H2F&
    WM_CHILDACTIVATE = &H22&
    WM_CLEAR = &H303&
    WM_CLOSE = &H10&
    WM_COMMAND = &H111&
    WM_COMPACTING = &H41&
    WM_COMPAREITEM = &H39&
    WM_CONVERTREQUESTEX = &H108&
    WM_COPY = &H301&
    WM_COPYDATA = &H4A&
    WM_CREATE = &H1&
    WM_CTLCOLORDLG = &H136&
    WM_CTLCOLORBTN = &H135&
    WM_CTLCOLOREDIT = &H133&
    WM_CTLCOLORLISTBOX = &H134&
    WM_CTLCOLORMSGBOX = &H132&
    WM_CTLCOLORSCROLLBAR = &H137&
    WM_CTLCOLORSTATIC = &H138&
    WM_CUT = &H300&
    WM_DDE_FIRST = &H3E0&
    WM_DDE_ACK& = (WM_DDE_FIRST& + 4)
    WM_DDE_ADVISE& = (WM_DDE_FIRST + 2)
    WM_DDE_DATA& = (WM_DDE_FIRST + 5)
    WM_DDE_EXECUTE& = (WM_DDE_FIRST + 8)
    WM_DDE_INITIATE& = (WM_DDE_FIRST)
    WM_DDE_LAST& = (WM_DDE_FIRST + 8)
    WM_DDE_POKE& = (WM_DDE_FIRST + 7)
    WM_DDE_REQUEST& = (WM_DDE_FIRST + 6)
    WM_DDE_TERMINATE& = (WM_DDE_FIRST + 1)
    WM_DDE_UNADVISE& = (WM_DDE_FIRST + 3)
    WM_DEADCHAR& = &H103
    WM_DELETEITEM& = &H2D
    WM_DESTROY& = &H2
    WM_DESTROYCLIPBOARD& = &H307
    WM_DEVMODECHANGE& = &H1B
    WM_DRAWCLIPBOARD& = &H308
    WM_DRAWITEM& = &H2B
    WM_DROPFILES& = &H233
    WM_ENABLE& = &HA
    WM_ENDSESSION& = &H16
    WM_ENTERMENULOOP& = &H211
    WM_ENTERIDLE& = &H121
    WM_ERASEBKGND& = &H14
    WM_EXITMENULOOP& = &H212
    WM_FONTCHANGE& = &H1D
    WM_GETDLGCODE& = &H87
    WM_GETFONT& = &H31
    WM_GETHOTKEY& = &H33
    WM_GETMINMAXINFO& = &H24
    WM_GETTEXT& = &HD
    WM_GETTEXTLENGTH& = &HE
    WM_HOTKEY& = &H312
    WM_HSCROLL& = &H114
    WM_HSCROLLCLIPBOARD& = &H30E
    WM_ICONERASEBKGND& = &H27
    WM_IME_CHAR& = &H286
    WM_IME_COMPOSITION& = &H10F
    WM_IME_COMPOSITIONFULL& = &H284
    WM_IME_CONTROL& = &H283
    WM_IME_ENDCOMPOSITION& = &H10E
    WM_IME_KEYDOWN& = &H290
    WM_IME_KEYLAST& = &H10F
    WM_IME_KEYUP& = &H291
    WM_IME_NOTIFY& = &H282
    WM_IME_SELECT& = &H285
    WM_IME_SETCONTEXT& = &H281
    WM_IME_STARTCOMPOSITION& = &H10D
    WM_INITDIALOG& = &H110
    WM_INITMENU& = &H116
    WM_INITMENUPOPUP& = &H117
    WM_KEYDOWN& = &H100
    WM_KEYFIRST& = &H100
    WM_KEYLAST& = &H108
    WM_KEYUP& = &H101
    WM_KILLFOCUS& = &H8
    WM_LBUTTONDBLCLK& = &H203
    WM_LBUTTONDOWN& = &H201
    WM_LBUTTONUP& = &H202
    WM_MBUTTONDBLCLK& = &H209
    WM_MBUTTONDOWN& = &H207
    WM_MBUTTONUP& = &H208
    WM_MDIACTIVATE& = &H222
    WM_MDICASCADE& = &H227
    WM_MDICREATE& = &H220
    WM_MDIDESTROY& = &H221
    WM_MDIGETACTIVE& = &H229
    WM_MDIICONARRANGE& = &H228
    WM_MDIMAXIMIZE& = &H225
    WM_MDINEXT& = &H224
    WM_MDIREFRESHMENU = &H234
    WM_MDIRESTORE = &H223
    WM_MDISETMENU = &H230
    WM_MDITILE = &H226
    WM_MEASUREITEM = &H2C
    WM_MENUCHAR = &H120
    WM_MENUSELECT = &H11F
    WM_MOUSEACTIVATE = &H21
    WM_MOUSEFIRST = &H200
    WM_MOUSELAST = &H209
    WM_MOUSEMOVE = &H200
    WM_MOVE = &H3
    WM_NCACTIVATE = &H86
    WM_NCCALCSIZE = &H83
    WM_NCCREATE = &H81
    WM_NCDESTROY = &H82
    WM_NCHITTEST = &H84
    WM_NCLBUTTONDBLCLK = &HA3
    WM_NCLBUTTONDOWN = &HA1
    WM_NCLBUTTONUP = &HA2
    WM_NCMBUTTONDBLCLK = &HA9
    WM_NCMBUTTONDOWN = &HA7
    WM_NCMBUTTONUP = &HA8
    WM_NCMOUSEMOVE = &HA0
    WM_NCPAINT = &H85
    WM_NCRBUTTONDOWN = &HA4
    WM_NCRBUTTONDBLCLK = &HA6
    WM_NCRBUTTONUP = &HA5
    WM_NEXTDLGCTL = &H28
    WM_NULL = &H0
    WM_OTHERWINDOWCREATED = &H42               '  no longer suported
    WM_OTHERWINDOWDESTROYED = &H43             '  no longer suported
    WM_PAINT = &HF
    WM_PAINTCLIPBOARD = &H309
    WM_PAINTICON = &H26
    WM_PALETTECHANGED = &H311
    WM_PALETTEISCHANGING = &H310
    WM_PARENTNOTIFY = &H210
    WM_PASTE = &H302
    WM_PENWINFIRST = &H380
    WM_PENWINLAST = &H38F
    WM_POWER = &H48
    WM_PSD_ENVSTAMPRECT = (WM_USER + 5)
    WM_PSD_FULLPAGERECT = (WM_USER + 1)
    WM_PSD_GREEKTEXTRECT = (WM_USER + 4)
    WM_PSD_MARGINRECT = (WM_USER + 3)
    WM_PSD_MINMARGINRECT = (WM_USER + 2)
    WM_PSD_PAGESETUPDLG = (WM_USER)
    WM_PSD_YAFULLPAGERECT = (WM_USER + 6)
    WM_QUERYDRAGICON = &H37
    WM_QUERYENDSESSION = &H11
    WM_QUERYNEWPALETTE = &H30F
    WM_QUERYOPEN = &H13
    WM_QUEUESYNC = &H23
    WM_QUIT = &H12
    WM_RBUTTONDBLCLK = &H206
    WM_RBUTTONDOWN = &H204
    WM_RBUTTONUP = &H205
    WM_RENDERALLFORMATS = &H306
    WM_SETCURSOR = &H20
    WM_RENDERFORMAT = &H305
    WM_SETFOCUS = &H7
    WM_SETFONT = &H30
    WM_SETHOTKEY = &H32
    WM_SETREDRAW = &HB
    WM_SETTEXT = &HC
    WM_SHOWWINDOW = &H18
    WM_SIZE = &H5
    WM_SIZECLIPBOARD = &H30B
    WM_SPOOLERSTATUS = &H2A
    WM_SYSCHAR = &H106
    WM_SYSCOLORCHANGE = &H15
    WM_SYSCOMMAND = &H112
    WM_SYSDEADCHAR = &H107
    WM_SYSKEYDOWN = &H104
    WM_SYSKEYUP = &H105
    WM_TIMECHANGE = &H1E
    WM_TIMER = &H113
    WM_UNDO = &H304
    WM_VKEYTOITEM = &H2E
    WM_VSCROLL = &H115
    WM_VSCROLLCLIPBOARD = &H30A
    WM_WINDOWPOSCHANGED = &H47
    WM_WINDOWPOSCHANGING = &H46
    WM_WININICHANGE = &H1A
End Enum
Public Function HIWORD(ByVal dwValue As Long) As Long
    Dim hexstr As String
    hexstr = Right("00000000" & Hex(dwValue), 8)
    HIWORD = CLng("&H" & Left(hexstr, 4))
End Function

Public Function GetEditLine(Handle As Long, LineNumber As Long) As String
    Dim LineLength As Integer
    Dim LineResult As String
    Dim CharIndex As Long
    CharIndex = SendMessage(Handle, EM_LINEINDEX, ByVal LineNumber, ByVal CLng(0))
        '//Get the letter number for which this line starts.
    LineLength = SendMessage(Handle, EM_LINELENGTH, ByVal CharIndex, ByVal CLng(0))
    If LineLength < 2 Then
        LineResult = Space(2)
    Else
        LineResult = Space(LineLength)
    End If
    CopyMemory ByVal LineResult, LineLength, Len(LineLength)
    SendMessage Handle, EM_GETLINE, ByVal LineNumber, ByVal LineResult
    GetEditLine = Left(LineResult, LineLength)
End Function
